using System;
using System.Diagnostics;
using System.Windows.Forms;
using Microsoft.DirectX;
using Microsoft.DirectX.DirectSound;

namespace WhackAMole
{
	public delegate void SoundTerminated(SecondaryBuffer buffer);

	/// <summary>
	/// Summary description for SoundTerminationNotifier.
	/// </summary>
	public class SoundTerminationNotifier
	{
		private SecondaryBuffer buffer;
		private SoundTerminated callback;

		private System.Windows.Forms.Timer terminationTimer = new System.Windows.Forms.Timer();

		public SoundTerminationNotifier(SecondaryBuffer buffer, SoundTerminated callback)
		{
			this.buffer = buffer;
			this.callback = callback;

			terminationTimer = new System.Windows.Forms.Timer();
			terminationTimer.Interval = 50;
			terminationTimer.Tick += new System.EventHandler(terminationTimer_Tick);
		}

		public void Start()
		{
			if(buffer != null)
			{
				Trace.WriteLine("MOOOOOO!");
				terminationTimer.Start();
			}
		}

		private void terminationTimer_Tick(object sender, System.EventArgs e)
		{
			Trace.WriteLine(buffer.Status.ToString());
			if(!buffer.Status.Playing)
			{
				Trace.WriteLine("FUTHER!");
				terminationTimer.Stop();
				if(callback != null)
				{
					callback(buffer);
				}
			}
		}
	}
}